

  #include <LiquidCrystal.h>
  LiquidCrystal lcd(26, 1, 2, 3, 4, 5);
  
  #include <EEPROM.h>
  #include <Bounce2.h>
  Bounce button = Bounce();


/////////INITIALIZE LONG-SHORT PRESS//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  #define buttonPin 19
  #define shortTime 250
  #define longTime 250
  
  #define noEvent    0
  #define shortPress 1
  #define longPress  2
  
  unsigned long buttonPressStartTimeStamp;
  unsigned long buttonPressDuration;
  boolean startTimeout = false;
  boolean endTimeout = false;
  byte event;
  
  boolean shortPressEnabled = false;
  boolean autoEnabled = true;
  byte longPressCount = 0;
   int lastCounter = 0;
  unsigned long lastAutoIncrement = millis();

////INITIALIZE ENCODERS///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

 #define encoder0PinA  22
 #define encoder0PinB  21

 #define encoder1PinA  20
 #define encoder1PinB  15
 
 #define encoder2PinA  6
 #define encoder2PinB  7

 #define encoder3PinA  11
 #define encoder3PinB  12
 
/////////////INITIALIZE BUTTONS//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  static int hits = 1;
  int switchState = 0;
  int switchState2 = 0;
  int prevSwitchState = 0;
  int prevSwitchState2 = 0;
  const int switchPin = 8;
  const int switchPin2 = 9;
  unsigned long savePress=0;
  unsigned long loadPress=0;
 

////////OUTPUTS///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  int fbkpin = 16;
  int mixpin = 17;
  int outpin = 23;
  int glidepin = 10;
  
  int mix = 255;
  int fbk = 0;
  float glide = 0;
  float var=1;
  int ii = 0;
/////////CUSTOM CHARACTERS//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

byte p20[8]   = {0b11111,0b10001,0b10001,0b10001,0b10001,0b10001,0b10001,0b11111};
byte forw[8]  = {0b10000,0b11000,0b11100,0b11110,0b11100,0b11000,0b10000,0b00000};
byte backw[8] = {0b00001,0b00011,0b00111,0b01111,0b00111,0b00011,0b00001,0b00000};
byte dash[8]  = {0b11111,0b11111,0b11111,0b11111,0b11111,0b11111,0b11111,0b11111};

int array1[] = {4,5,6,7,3};

byte tenp[8]    = {0b10000,0b10000,0b10000,0b10000,0b10000,0b10000,0b10000,0b10000};
byte twentyp[8] = {0b11000,0b11000,0b11000,0b11000,0b11000,0b11000,0b11000,0b11000};
byte thirtyp[8] = {0b11100,0b11100,0b11100,0b11100,0b11100,0b11100,0b11100,0b11100};
byte fortyp[8]  = {0b11110,0b11110,0b11110,0b11110,0b11110,0b11110,0b11110,0b11110};

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////INITIALIZE ARRAYS/////////////INITIALIZE ARRAYS/////////////INITIALIZE ARRAYS/////////////INITIALIZE ARRAYS/////////////INITIALIZE ARRAYS/////////////INITIALIZE ARRAYS//////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  float val[] = {12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12};

  char const*scale[] = {"CHR","MAJ", "MIN", "MEL", "HAR","DET"};
  float scl = 0;

char*pitch[] = {

pitch[0] = "-12",
pitch[1] = "-11",
pitch[2] = "-10",
pitch[3] = "-9 ",
pitch[4] = "-8 ",
pitch[5] = "-7 ",
pitch[6] = "-6 ",
pitch[7] = "-5 ",
pitch[8] = "-4 ",
pitch[9] = "-3 ",
pitch[10] = "-2 ",
pitch[11] = "-1 ",
pitch[12] = " 0 ",
pitch[13] = "+1 ",
pitch[14] = "+2 ",
pitch[15] = "+3 ",
pitch[16] = "+4 ",
pitch[17] = "+5 ",
pitch[18] = "+6 ",
pitch[19] = "+7 ",
pitch[20] = "+8 ",
pitch[21] = "+9 ",
pitch[22] = "+10",
pitch[23] = "+11",
pitch[24] = "+12"
};

float step1[] = {
step1[0] = 1, //12
step1[1] = 10, //11
step1[2] = 18,  //10
step1[3] = 28,  //9
step1[4] = 38, //8
step1[5] = 47, //7
step1[6] = 54, //6
step1[7] = 60, //5
step1[8] = 69, //4
step1[9] = 77, //3
step1[10] = 85, //2
step1[11] = 90,//1
step1[12] = 99, //0
step1[13] = 107, //1
step1[14] = 117,//2
step1[15] = 124,//3
step1[16] = 130,//4
step1[17] = 140,//5
step1[18] = 150,//6
step1[19] = 157,//7
step1[20] = 165,//8
step1[21] = 171,//9
step1[22] = 179,//10
step1[23] = 189,//11
step1[24] = 200//12
};


int roundGlide = 0;
int inc = 0;


int glideArray[] = 
{255,48,46,44,42,
40,38,36,33,31,
30,29,28,27,26,
25,24,23,22,21,
20,19,18,17,16,
15,14,13,12,11,
10,9,8,7,6,5,
4,3,2,1,0};
  

//////INITALIZE TAP TEMPO STUFF///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  const int tapPin = 19;
  float multiplier[] = {0.25,0.333333333333333333333333333333333333333333333333,0.5,0.75,1,1.5,2.00000,3.00000,4.00000,5.00000,6.00000,7.00000,8.00000};
  char const*mx[] = {"1/4","1/3","1/2","3/4","1.0","3/2","2.0","3.0","4.0","5.0","6.0","7.0","8.0"};
  float sixtyk[] = {240000,180000,120000,80000,60000,40000,30000,15000,12000,10000,8571.42857, 7500};
  float mult = 4;
  int lastTapState = HIGH;
  byte bpmTaps[10] = { // required for tap tempo
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

  const int ledPin =  13;
  int ledState = LOW;            
  unsigned long previousMillis2 = 0;  
  float previousMillisLED = 0;  
  

//////////INITIALIZE VARIABLES////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  float steps = 8;
  float dir = 0;
  int i=0;
  int randnum = 0;
  volatile float tempo = 120;
  float previousMillis = 0;  
  float previousMillis3 = 0; 
  float lcdpreviousMillis = 0; 
  int switchpreviousMillis=0;
  float bpm  =  120;

  
  #define up  true
  #define down  false
  boolean direction=up;
  
  float patch = 0;
  int patchNumber = 0;

//////////EEPROM///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 

  const byte EEPROM_ID=0x99;
  const int  ID_ADDRESS=0;
  const int  BASE_ADDRESS=1;
  const int savePin = 18;
  const int loadPin = 14;

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////SETUP/////////SETUP/////////SETUP/////////SETUP/////////SETUP/////////SETUP/////////SETUP/////////SETUP/////////SETUP/////////SETUP/////////SETUP/////////SETUP/////////SETUP////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void setup() { 

  pinMode(buttonPin, INPUT_PULLUP);
  button.attach(buttonPin);
  button.interval(20); 
   
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////ENCODERS////////ENCODERS////////ENCODERS////////ENCODERS////////ENCODERS////////ENCODERS////////ENCODERS////////ENCODERS////////ENCODERS////////ENCODERS////////ENCODERS////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  attachInterrupt(22, doEncoder0A, CHANGE);
  attachInterrupt(21, doEncoder0B, CHANGE);
  
  attachInterrupt(20, doEncoder1A, CHANGE);
  attachInterrupt(15, doEncoder1B, CHANGE);
  
  attachInterrupt(6, doEncoder2A, CHANGE);
  attachInterrupt(7, doEncoder2B, CHANGE);
  
  attachInterrupt(11, doEncoder3A, CHANGE);
  attachInterrupt(12, doEncoder3B, CHANGE);
  
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////MENU CHANGE BUTTONS////////MENU CHANGE BUTTONS////////MENU CHANGE BUTTONS////////MENU CHANGE BUTTONS////////MENU CHANGE BUTTONS////////MENU CHANGE BUTTONS////////MENU CHANGE BUTTONS
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  pinMode(switchPin,INPUT);
  pinMode(switchPin2,INPUT);
  pinMode(outpin,OUTPUT);
  pinMode(mixpin,OUTPUT);
  pinMode(fbkpin,OUTPUT);
  pinMode(ledPin, OUTPUT);
  pinMode(glidepin, OUTPUT);
  pinMode(savePin, INPUT);
  pinMode(loadPin, INPUT);

  lcd.createChar(0, p20);
  lcd.createChar(1, forw);
  lcd.createChar(2, backw);
  lcd.createChar(3, dash);
  lcd.createChar(4, tenp);
  lcd.createChar(5, twentyp);
  lcd.createChar(6, thirtyp);
  lcd.createChar(7, fortyp);
  
  lcd.begin(16, 2);
  lcd.clear();
  animation();

  lcd.clear();
  
  pinMode(ledPin, OUTPUT); 
  digitalWrite(ledPin, HIGH); 


 }///////END SETUP////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////VOID LOOP//////////VOID LOOP//////////VOID LOOP//////////VOID LOOP//////////VOID LOOP//////////VOID LOOP//////////VOID LOOP//////////VOID LOOP//////////VOID LOOP/////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void loop() { 

  doEncoders();
  lcdUpdate();
  storeDataToEPROM();
  readDataFromEPROM();
  sequencer();

  analogWrite(mixpin,mix);
  analogWrite(glidepin,glideArray[round(glide)]); 
  analogWrite(fbkpin,fbk*.5);
  analogWrite(outpin, step1[round(val[i])]);

  patchNumber = round(patch);
  

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////MENU CHANGE//////////MENU CHANGE//////////MENU CHANGE//////////MENU CHANGE//////////MENU CHANGE//////////MENU CHANGE//////////MENU CHANGE//////////MENU CHANGE///////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  switchState = digitalRead(switchPin);
  if (switchState != prevSwitchState) {
    if (switchState == HIGH) {
      unsigned long switchcurrentMillis = millis();
      if(switchcurrentMillis - switchpreviousMillis > 250) {
        switchpreviousMillis = switchcurrentMillis; 
        hits = hits + 1;
        lcd.setCursor(0,0);
        lcd.print("                          ");
        lcd.setCursor(0,1);
        lcd.print("                          ");
      } 
    }
  }//////////END UP PAGE//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  
  switchState2 = digitalRead(switchPin2);
  if (switchState2 != prevSwitchState2) {
    if (switchState2 == HIGH) {
      unsigned long switchcurrentMillis = millis();
      if(switchcurrentMillis - switchpreviousMillis > 250) {
        switchpreviousMillis = switchcurrentMillis; 
        hits = hits - 1;
        lcd.setCursor(0,0);
        lcd.print("                          ");
        lcd.setCursor(0,1);
        lcd.print("                          ");
      }
    }
  }///////END DOWN PAGE////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////MENU PAGE 1///////////MENU PAGE 1///////////MENU PAGE 1///////////MENU PAGE 1///////////MENU PAGE 1///////////MENU PAGE 1///////////MENU PAGE 1///////////MENU PAGE 1/////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

if(hits==1){

  lcd.setCursor(0, 0);
  lcd.print("MULT STEP MODE P");
  
  lcd.setCursor(1, 1);
  lcd.print(mx[round(mult)]);
  
  lcd.setCursor(0, 1);
  lcd.print("x");
  
  lcd.setCursor(6, 1);
  lcd.print(String(round(steps))+" ");  
  
  arrows();
  
  lcd.setCursor(15, 1);
  lcd.print(patchNumber);
  
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////MENU PAGE 2/////////MENU PAGE 2/////////MENU PAGE 2/////////MENU PAGE 2/////////MENU PAGE 2/////////MENU PAGE 2/////////MENU PAGE 2/////////MENU PAGE 2/////////MENU PAGE 2///////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

if(hits==2){

  lcd.setCursor(0, 0);
  lcd.print("MIX FBK PORT QNT");
  
  progressbar();
  
  analogWrite(mixpin,mix);
  analogWrite(fbkpin,round(fbk*0.5));
  analogWrite(glidepin,glideArray[round(glide)]);
  
  lcd.setCursor(13,1);
  lcd.print(scale[round(scl)]);

  
}/////END PAGE 2//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////MENU PAGE 3/////////MENU PAGE 3/////////MENU PAGE 3/////////MENU PAGE 3/////////MENU PAGE 3/////////MENU PAGE 3/////////MENU PAGE 3/////////MENU PAGE 3/////////MENU PAGE 3///////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

if(hits==3){

  lcd.setCursor(0, 0);
  lcd.print("  1   2   3   4 ");

  lcd.setCursor(1, 1);
  lcd.print(pitch[round(val[0])]);
  
  lcd.setCursor(5, 1);
  lcd.print(pitch[round(val[1])]);
  
  lcd.setCursor(9, 1);
  lcd.print(pitch[round(val[2])]);
  
  lcd.setCursor(13, 1);
  lcd.print(pitch[round(val[3])]);
 
  
   
   }///////END PAGE 3//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
   
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////MENU PAGE 4/////////MENU PAGE 4/////////MENU PAGE 4/////////MENU PAGE 4/////////MENU PAGE 4/////////MENU PAGE 4/////////MENU PAGE 4/////////MENU PAGE 4/////////MENU PAGE 4///////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

if(hits==4){

  lcd.setCursor(0, 0);
  lcd.print("  5   6   7   8 ");
  
  lcd.setCursor(1, 1);
  lcd.print(pitch[round(val[4])]);
  
  lcd.setCursor(5, 1);
  lcd.print(pitch[round(val[5])]);
  
  lcd.setCursor(9, 1);
  lcd.print(pitch[round(val[6])]);
  
  lcd.setCursor(13, 1);
  lcd.print(pitch[round(val[7])]);
  
}///////END PAGE 4/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
   
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////MENU PAGE 5/////////MENU PAGE 5/////////MENU PAGE 5/////////MENU PAGE 5/////////MENU PAGE 5/////////MENU PAGE 5/////////MENU PAGE 5/////////MENU PAGE 5/////////MENU PAGE 5///////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

if(hits==5){

  lcd.setCursor(0, 0);
  lcd.print("  9  10  11  12 ");
  
  lcd.setCursor(1, 1);
  lcd.print(pitch[round(val[8])]);
  
  lcd.setCursor(5, 1);
  lcd.print(pitch[round(val[9])]);
  
  lcd.setCursor(9, 1);
  lcd.print(pitch[round(val[10])]);
  
  lcd.setCursor(13, 1);
  lcd.print(pitch[round(val[11])]);
   
   }///////END PAGE 5//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////MENU PAGE 6/////////MENU PAGE 6/////////MENU PAGE 6/////////MENU PAGE 6/////////MENU PAGE 6/////////MENU PAGE 6/////////MENU PAGE 6/////////MENU PAGE 6/////////MENU PAGE 6///////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

if(hits==6){

  lcd.setCursor(0, 0);
  lcd.print(" 13  14  15  16 ");
  
  lcd.setCursor(1, 1);
  lcd.print(pitch[round(val[12])]);
  
  lcd.setCursor(5, 1);
  lcd.print(pitch[round(val[13])]);
  
  lcd.setCursor(9, 1);
  lcd.print(pitch[round(val[14])]);
  
  lcd.setCursor(13, 1);
  lcd.print(pitch[round(val[15])]);


   }///////END PAGE 6//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////MENU PAGE 7/////////MENU PAGE 7/////////MENU PAGE 7/////////MENU PAGE 7/////////MENU PAGE 7/////////MENU PAGE 7/////////MENU PAGE 7/////////MENU PAGE 7/////////MENU PAGE 7///////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

if(hits==7){
  
  lcd.setCursor(8, 0);
  lcd.print(String(round(steps))+" "); 
  
  arrows();

  for(int k = 0;k<(round(steps));k++){
    lcd.setCursor(k,1);
    lcd.write(3);
    lcd.setCursor(i,1);
    lcd.write(dash[8]);
  }
  for(int j = 16;j>=(round(steps));j--){
    lcd.setCursor(j,1);
    lcd.write(" ");
    lcd.setCursor(i,1);
    lcd.write(dash[8]);
  }

  if(shortPressEnabled == true){
    lcd.setCursor(0, 0);
    lcd.print("TRIG.");
    lcd.setCursor(6, 0);
    lcd.print("S:");
    lcd.setCursor(11, 0);
    lcd.print("M:");
    lcd.setCursor(8, 0);
    lcd.print(String(round(steps))+" ");
  }
}////END PAGE 7///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  if(hits>7){
    hits = 1;
    }else
  
  if(hits<1){
    hits = 7;
    }
    
}////////END VOID LOOP///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
